#!/bin/sh
[ -z "$1" ] && {
	echo "$0 [--regen] klient1 klient2 klient3 ..."
	exit 1
}

CNAME='vpn-hub'
TDIR=`mktemp -t -d vpn_doit.XXXXXX` || exit 1
trap "rm -fr $TDIR" exit

cd `dirname $0`/easyrsa

. vars

RECONF=

if [ "$1" == "--regen" ]; then
	RECONF=1;
	shift;
fi


for NAME in $@ ; do 
	echo "Generating client $NAME"
	if [ $RECONF ]; then
		if [ ! -e ../keys/$NAME.key -o ! -e ../keys/$NAME.crt ]; then
			echo "Client $NAME can't be reconfigured"
			continue
		fi
	else
		./pkitool $NAME
	fi
	cp -r ../template/vpn-hub-install $TDIR
	cp ../template/ca.crt $TDIR/vpn-hub-install/config/
	cp ../template/secret.key $TDIR/vpn-hub-install/config/
	cp ../keys/$NAME.crt $TDIR/vpn-hub-install/config/
	cp ../keys/$NAME.key $TDIR/vpn-hub-install/config/
	sed -e "s/%NAME%/$NAME/" ../template/client.conf > $TDIR/vpn-hub-install/config/$CNAME.ovpn
	rm -f ../out/$NAME.zip
	ODIR=`pwd`
	cd $TDIR
	zip -r -q -9 "$ODIR/../out/$NAME.zip" vpn-hub-install
	cd $ODIR
done
	
	
